/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.blocks.wood;

import java.util.HashMap;
import java.util.Map;

import net.minecraft.block.BlockChest;
import net.minecraft.block.SoundType;
import net.minecraft.init.Blocks;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;

import net.dries007.tfc.api.types.Tree;
import net.dries007.tfc.objects.te.TEChestTFC;

import net.minecraft.block.BlockChest.Type;

public class BlockChestTFC extends BlockChest
{
    private static final Map<Tree, BlockChestTFC> MAP_BASIC = new HashMap<>();
    private static final Map<Tree, BlockChestTFC> MAP_TRAP = new HashMap<>();

    public static BlockChestTFC getBasic(Tree wood)
    {
        return MAP_BASIC.get(wood);
    }

    public static BlockChestTFC getTrap(Tree wood)
    {
        return MAP_TRAP.get(wood);
    }

    public final Tree wood;

    public BlockChestTFC(Type type, Tree wood)
    {
        super(type);
        this.wood = wood;
        func_149711_c(2.5F);
        func_149672_a(SoundType.field_185848_a);
        switch (type)
        {
            case BASIC:
                if (MAP_BASIC.put(wood, this) != null) throw new IllegalStateException("There can only be one.");
                break;
            case TRAP:
                if (MAP_TRAP.put(wood, this) != null) throw new IllegalStateException("There can only be one.");
                break;
            default:
                throw new IllegalStateException();
        }
        Blocks.field_150480_ab.func_180686_a(this, 5, 20);
    }

    @Override
    public TileEntity func_149915_a(World worldIn, int meta)
    {
        return new TEChestTFC();
    }
}
